//+------------------------------------------------------------------+
//|                                             SHI_Channel_true.mq4 |
//|                                 Copyright  2004, Shurka & Kevin |
//|                                    alerts 11.2013 by fxdaytrader |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, Shurka & Kevin (alerts by fxdaytrader)"
#property link      "http://forexBaron.net"
//----
#property indicator_chart_window
#property indicator_buffers 1

double ExtMapBuffer1[];

//---- input parameters
extern string LineStyleInfo2 = "0 = Solid, 1 = Dash, 2 = Dot, 3 = DashDot, 4 = DashDotDot";
extern string style1 = 2;
extern int    AllBars=240;
extern int    BarsForFract=0;
extern color  color1 = Yellow;
extern int  pipDistance = 10; //HELP, how to include in Code?!

//alerts/misc, fxdaytrader:
extern bool   ShowScreenComment      = true;
extern string ahi="******* ALERT SETTINGS:";
extern int    AlertCandle            = 0;//0:current, 1:last bar, etc.
extern bool   PopupAlerts            = true;
extern bool   EmailAlerts            = false;
extern bool   PushNotificationAlerts = false;
extern bool   SoundAlerts            = false;
extern string SoundFileHigh          = "alert.wav";
extern string SoundFileLow           = "alert2.wav";
//int lastAlert=3;
double alertTag;

//end alerts/misc

int    CurrentBar = 0;
double Step = 0;
int    B1 = -1, B2 = -1;
int    UpDown = 0;
double P1 = 0, P2 = 0, PP = 0;
int    i = 0, AB = 300, BFF = 0;
int    ishift = 0;
double iprice = 0;
datetime T1, T2;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 164);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexEmptyValue(0, 0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
	  ObjectDelete("TL1");
	  ObjectDelete("TL2");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DelObj()
  {
	  ObjectDelete("TL1");
	  ObjectDelete("TL2");
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars = IndicatorCounted();
//---- 
	  if((AllBars == 0) || (Bars < AllBars)) 
	      AB = Bars; 
	  else AB = AllBars;
	  if(BarsForFract > 0) 
		     BFF = BarsForFract; 
	  else
		     switch (Period())
		       {
			        case     1: BFF = 12; break;
			        case     5: BFF = 48; break;
			        case    15: BFF = 24; break;
			        case    30: BFF = 24; break;
			        case    60: BFF = 12; break;
			        case   240: BFF = 15; break;
			        case  1440: BFF = 10; break;
			        case 10080: BFF = 6;  break;
			        default: DelObj(); return(-1); break;
		       }
   CurrentBar = 2;
   B1 = -1; 
   B2 = -1; 
   UpDown = 0;
   while(((B1 == -1) || (B2==-1)) && (CurrentBar<AB))
     {
		     if((UpDown < 1) && (CurrentBar == Lowest(Symbol(), Period(), MODE_LOW, BFF*2 + 1,
		        CurrentBar - BFF))) 
		       {
			        if(UpDown == 0) 
			          { 
			            UpDown = -1; 
			            B1 = CurrentBar; 
			            P1 = Low[B1]; 
			          }
			        else 
			          { 
			            B2 = CurrentBar; 
			            P2 = Low[B2];
			          }
		       }
		     if((UpDown > -1) && (CurrentBar == Highest(Symbol(), Period(), MODE_HIGH, BFF*2 + 1,
		        CurrentBar - BFF))) 
		       {
			        if(UpDown == 0) 
			          { 
			            UpDown = 1; 
			            B1 = CurrentBar; 
			            P1 = High[B1]; 
			          }
			        else 
			          { 
			            B2 = CurrentBar; 
			            P2 = High[B2]; 
			          }
		       }
		     CurrentBar++;
	    }
	  if((B1 == -1) || (B2 == -1)) 
	    {
	      DelObj(); 
	      return(-1);
	    } 
	  Step = (P2 - P1) / (B2 - B1); 
	  P1 = P1 - B1*Step; 
	  B1 = 0; 
	  ishift = 0; 
	  iprice = 0;
	  if(UpDown == 1)
	    { 
		     PP = Low[2] - 2*Step;
		     for(i = 3; i <= B2; i++) 
		       {
			        if(Low[i] < PP + Step*i) 
			            PP = Low[i] - i*Step; 
		       }
		     if(Low[0] < PP) 
		       {
		         ishift = 0; 
		         iprice = PP;
		       }
		     if(Low[1] < PP + Step) 
		       {
		         ishift = 1; 
		         iprice = PP + Step;
		       }
		     if(High[0] > P1) 
		       {
		         ishift = 0; 
		         iprice = P1;
		       }
		     if(High[1] > P1 + Step) 
		       {
		         ishift = 1; 
		         iprice = P1 + Step;
		       }
	    } 
	  else
	    { 
		     PP = High[2] - 2*Step;
		     for(i = 3; i <= B2; i++) 
		       {
			        if(High[i] > PP + Step*i) 
			            PP = High[i] - i*Step;
		       }
		     if(Low[0] < P1) 
		       {
		         ishift = 0; 
		         iprice = P1;
		       }
		     if(Low[1] < P1 + Step) 
		       {
		         ishift = 1; 
		         iprice = P1 + Step;
		       }
		     if(High[0] > PP) 
		       {
		         ishift = 0; 
		         iprice = PP;
		       }
		     if(High[1] > PP + Step) 
		       {
		         ishift = 1; 
		         iprice = PP + Step;
		       }
	    }

	  P2 = P1 + AB*Step;
	  T1 = Time[B1]; 
	  T2 = Time[AB];

	  if(iprice != 0) 
	      ExtMapBuffer1[ishift] = iprice;
	  DelObj();
	  ObjectCreate("TL1", OBJ_TREND, 0, T2, PP + Step*AB, T1, PP); 
		 ObjectSet("TL1", OBJPROP_COLOR, color1); 
		 ObjectSet("TL1", OBJPROP_WIDTH, 1); 
		 ObjectSet("TL1", OBJPROP_STYLE, style1); 
	  ObjectCreate("TL2", OBJ_TREND, 0, T2, P2, T1, P1); 
		 ObjectSet("TL2", OBJPROP_COLOR, color1); 
		 ObjectSet("TL2", OBJPROP_WIDTH, 1); 
		 ObjectSet("TL2", OBJPROP_STYLE, style1); 
     CheckForLineTouch();
//----
   return(0);
  }
//+------------------------------------------------------------------+


//////////////////////////////////////////////////////////////////////
//stuff by fxdaytrader:
double GetObjectPrice(string objname,int objshift) {
 return(ObjectGetValueByShift(objname,objshift));
}//double GetObjectPrice(string objname,int objshift) {

bool ObjTouched(string objname,int shift) {
 double price=ObjectGetValueByShift(objname,shift);
  if (iHigh(NULL,0,shift)>=price  && iClose(NULL,0,shift+1) <price) return(true);
  if (iLow(NULL,0,shift)<=price  && iClose(NULL,0,shift)    >price) return(true);
 return(false);
}//bool ObjTouched(string objname,int shift) {

void CheckForLineTouch() {
 double price1=GetObjectPrice("TL1",AlertCandle);
 double price2=GetObjectPrice("TL2",AlertCandle);
 string msg="SHI Channel Alert on "+Symbol()+", period "+TFtoStr(Period())+": ";

 if //(lastAlert!=1 && 
 ((ObjTouched("TL2",AlertCandle) && price2>price1 && alertTag!=Time[0]) || (ObjTouched("TL1",AlertCandle) && price1>price2 && alertTag!=Time[0]))  {
  msg=msg+"UPPER LINE TOUCHED";
  doAlerts(msg,SoundFileHigh);
  alertTag=Time[0];
  //lastAlert=1;
 }

 if //(lastAlert!=2 && 
 ((ObjTouched("TL2",AlertCandle) && price2<price1 && alertTag!=Time[0]) || (ObjTouched("TL1",AlertCandle) && price1<price2 && alertTag!=Time[0]))  {
  msg=msg+"LOWER LINE TOUCHED";
  doAlerts(msg,SoundFileLow);
  alertTag=Time[0];
  //lastAlert=2;
 }
}//void CheckForLineTouch() {

void doAlerts(string msg,string SoundFile) {
  if (PopupAlerts) Alert(msg);
  if (SoundAlerts) PlaySound(SoundFile);
}//void doAlerts(string msg,string SoundFile) {

string TFtoStr(int period) {
 switch(period) {
  case 1     : return("M1");  break;
  case 5     : return("M5");  break;
  case 15    : return("M15"); break;
  case 30    : return("M30"); break;
  case 60    : return("H1");  break;
  case 240   : return("H4");  break;
  case 1440  : return("D1");  break;
  case 10080 : return("W1");  break;
  case 43200 : return("MN1"); break;
  default    : return(DoubleToStr(period,0));
 }
 return("UNKNOWN");
}


//string TFtoStr(int period) {
//end stuff by fxdaytrader
//////////////////////////////////////////////////////////////////////

